setwd("/Users/junINOUEpro/Downloads/treePlot")

library(ape)

taxonSampling    <- "Deuterostomia"
outfileName      <- "out"


greenPrefixes <- c(); purplePrefixes <- c(); orangePrefixes <- c(); redPrefixes <-c(); bluePrefixes <- c()
if (taxonSampling == "Protostomia") {
  greenPrefixes   <- c('Adineta-vaga_','Schistosoma-mansoni_','Capitella-teleta_','Helobdella-robusta_','Notospermus-geniculatus_','Phoronis-australis_','Lingula-anatina_')
  purplePrefixes  <- c('Octopus-bimaculoides_','Lottia-gigantea_','Biomphalaria-glabrata_','Aplysia-californica_','Crassostrea-virginica_','Crassostrea-gigas_','Mizuhopecten-yessoensis_','Pinctada-fucata_')
  orangePrefixes  <- c('Priapulus-caudatus_','Trichinella-spiralis_','Strongyloides-ratti_','Onchocerca-volvulus_','Loa-loa_','Brugia-malayi_','Pristionchus-pacificus_','Caenorhabditis-japonica_','Caenorhabditis-elegans_','Caenorhabditis-brenneri_','Caenorhabditis-remanei_','Caenorhabditis-briggsae_')
  redPrefixes     <- c('Limulus-polyphemus_','Sarcoptes-scabiei_','Tetranychus-urticae_','Ixodes-scapularis_','Centruroides-sculpturatus_','Parasteatoda-tepidariorum_','Stegodyphus-mimosarum_')
  bluePrefixes    <- c('Strigamia-maritima_','Hyalella-azteca_','Eurytemora-affinis_','Lepeophtheirus-salmonis_','Daphnia-magna_','Daphnia-pulex_','Pediculus-humanus_','Zootermopsis-nevadensis_','Cryptotermes-secundus_','Rhodnius-prolixus_','Acyrthosiphon-pisum_','Nasonia-vitripennis_','Atta-cephalotes_','Solenopsis-invicta_','Apis-mellifera_','Bombus-impatiens_','Bombus-terrestris_','Tribolium-castaneum_','Anoplophora-glabripennis_','Dendroctonus-ponderosae_','Bombyx-mori_','Heliconius-melpomene_','Danaus-plexippus_','Melitaea-cinxia_','Belgica-antarctica_','Culex-quinquefasciatus_','Aedes-aegypti_','Anopheles-darlingi_','Mayetiola-destructor_','Megaselia-scalaris_','Teleopsis-dalmanni_','Lucilia-cuprina_','Drosophila-grimshawi_','Drosophila-mojavensis_','Drosophila-virilis_','Drosophila-willistoni_','Drosophila-pseudoobscura_','Drosophila-persimilis_','Drosophila-ananassae_','Drosophila-yakuba_','Drosophila-erecta_','Drosophila-simulans_','Drosophila-sechellia_','Drosophila-melanogaster_')
} else if (taxonSampling == "Deuterostomia") {
  greenPrefixes   <- c('Ptychodera-flava_','Saccoglossus-kowalevskii_')
  purplePrefixes  <- c('Strongylocentrotus-purpuratus_', 'Acanthaster-planci_', 'Acanthaster-planciGBR_')
  orangePrefixes  <- c('Branchiostoma-floridae_','Branchiostoma-belcheri_')
  redPrefixes     <- c('Oikopleura-dioica_', 'Botryllus-schlosseri_', 'Ciona-intestinalis_', 'Ciona-savignyi_')
  bluePrefixes    <- c('Petromyzon-marinus_','Callorhinchus-milii_','Rhincodon-typus_','Lepisosteus-oculatus_','Scleropages-formosus_','Paramormyrops-kingsleyae_','Clupea-harengus_','Ictalurus-punctatus_','Astyanax-mexicanus_','Pygocentrus-nattereri_','Danio-rerio_','Sinocyclocheilus-grahami_','Cyprinus-carpio_','Esox-lucius_','Salmo-salar_','Salvelinus-alpinus_','Oncorhynchus-mykiss_','Oncorhynchus-tshawytscha_','Oncorhynchus-kisutch_','Gadus-morhua_','Gasterosteus-aculeatus_','Notothenia-coriiceps_','Larimichthys-crocea_','Labrus-bergylta_','Tetraodon-nigroviridis_','Takifugu-rubripes_','Cynoglossus-semilaevis_','Paralichthys-olivaceus_','Lates-calcarifer_','Seriola-lalandi-dorsalis_','Seriola-dumerili_','Stegastes-partitus_','Amphiprion-ocellaris_','Acanthochromis-polyacanthus_','Oreochromis-niloticus_','Neolamprologus-brichardi_','Pundamilia-nyererei_','Maylandia-zebra_','Haplochromis-burtoni_','Boleophthalmus-pectinirostris_','Hippocampus-comes_','Monopterus-albus_','Oryzias-latipes_','Oryzias-melastigma_','Nothobranchius-furzeri_','Austrofundulus-limnaeus_','Cyprinodon-variegatus_','Fundulus-heteroclitus_','Xiphophorus-maculatus_','Poecilia-formosa_','Poecilia-reticulata_','Latimeria-chalumnae_','Xenopus-tropicalis_','Xenopus-laevis_','Gekko-japonicus_','Anolis-carolinensis_','Pogona-vitticeps_','Python-bivittatus_','Thamnophis-sirtalis_','Protobothrops-mucrosquamatus_','Pelodiscus-sinensis_','Chrysemys-picta_','Chelonia-mydas_','Alligator-mississippiensis_','Alligator-sinensis_','Ficedula-albicollis_','Anas-platyrhynchos_','Meleagris-gallopavo_','Taeniopygia-guttata_','Gallus-gallus_','Ornithorhynchus-anatinus_','Monodelphis-domestica_','Sarcophilus-harrisii_','Notamacropus-eugenii_','Loxodonta-africana_','Trichechus-manatus_','Procavia-capensis_','Orycteropus-afer_','Echinops-telfairi_','Dasypus-novemcinctus_','Choloepus-hoffmanni_','Erinaceus-europaeus_','Sorex-araneus_','Pteropus-vampyrus_','Myotis-lucifugus_','Equus-caballus_','Ceratotherium-simum_','Manis-javanica_','Felis-catus_','Canis-familiaris_','Mustela-putorius-furo_','Leptonychotes-weddellii_','Ailuropoda-melanoleuca_','Ursus-maritimus_','Camelus-bactrianus_','Vicugna-pacos_','Sus-scrofa_','Odocoileus-virginianus_','Bubalus-bubalis_','Bison-bison_','Bos-taurus_','Ovis-aries_','Capra-hircus_','Balaenoptera-acutorostrata_','Physeter-catodon_','Lipotes-vexillifer_','Tursiops-truncatus_','Orcinus-orca_','Otolemur-garnettii_','Microcebus-murinus_','Propithecus-coquereli_','Carlito-syrichta_','Aotus-nancymaae_','Callithrix-jacchus_','Cebus-capucinus_','Saimiri-boliviensis-boliviensis_','Nomascus-leucogenys_','Pongo-abelii_','Gorilla-gorilla_','Pan-troglodytes_','Pan-paniscus_','Homo-sapiens_','Colobus-angolensis-palliatus_','Rhinopithecus-roxellana_','Rhinopithecus-bieti_','Chlorocebus-sabaeus_','Papio-anubis_','Cercocebus-atys_','Mandrillus-leucophaeus_','Macaca-nemestrina_','Macaca-fascicularis_','Macaca-mulatta_','Tupaia-belangeri_','Oryctolagus-cuniculus_','Ochotona-princeps_','Ictidomys-tridecemlineatus_','Fukomys-damarensis_','Heterocephalus-glaber_','Octodon-degus_','Chinchilla-lanigera_','Cavia-porcellus_','Cavia-aperea_','Dipodomys-ordii_','Jaculus-jaculus_','Nannospalax-galili_','Peromyscus-maniculatus_','Cricetulus-griseus_','Rattus-norvegicus_','Mus-pahari_','Mus-spretus_','Mus-musculus_')
} else if (taxonSampling == "Vertebrata") {
  greenPrefixes   <- c('Petromyzon-marinus_','Callorhinchus-milii_','Rhincodon-typus_')
  purplePrefixes  <- c('Lepisosteus-oculatus_','Scleropages-formosus_','Paramormyrops-kingsleyae_','Clupea-harengus_','Ictalurus-punctatus_','Astyanax-mexicanus_','Pygocentrus-nattereri_','Danio-rerio_','Sinocyclocheilus-grahami_','Cyprinus-carpio_','Esox-lucius_','Salmo-salar_','Salvelinus-alpinus_','Oncorhynchus-mykiss_','Oncorhynchus-tshawytscha_','Oncorhynchus-kisutch_','Gadus-morhua_','Gasterosteus-aculeatus_','Notothenia-coriiceps_','Larimichthys-crocea_','Labrus-bergylta_','Tetraodon-nigroviridis_','Takifugu-rubripes_','Cynoglossus-semilaevis_','Paralichthys-olivaceus_','Lates-calcarifer_','Seriola-lalandi-dorsalis_','Seriola-dumerili_','Stegastes-partitus_','Amphiprion-ocellaris_','Acanthochromis-polyacanthus_','Oreochromis-niloticus_','Neolamprologus-brichardi_','Pundamilia-nyererei_','Maylandia-zebra_','Haplochromis-burtoni_','Boleophthalmus-pectinirostris_','Hippocampus-comes_','Monopterus-albus_','Oryzias-latipes_','Oryzias-melastigma_','Nothobranchius-furzeri_','Austrofundulus-limnaeus_','Cyprinodon-variegatus_','Fundulus-heteroclitus_','Xiphophorus-maculatus_','Poecilia-formosa_','Poecilia-reticulata_')
  orangePrefixes  <- c('Latimeria-chalumnae_','Xenopus-tropicalis_','Xenopus-laevis_','Gekko-japonicus_','Anolis-carolinensis_','Pogona-vitticeps_','Python-bivittatus_','Thamnophis-sirtalis_','Protobothrops-mucrosquamatus_')
  redPrefixes     <- c('Pelodiscus-sinensis_','Chrysemys-picta_','Chelonia-mydas_','Alligator-mississippiensis_','Alligator-sinensis_','Ficedula-albicollis_','Anas-platyrhynchos_','Meleagris-gallopavo_','Taeniopygia-guttata_','Gallus-gallus_')
  bluePrefixes    <- c('Ornithorhynchus-anatinus_','Monodelphis-domestica_','Sarcophilus-harrisii_','Notamacropus-eugenii_','Loxodonta-africana_','Trichechus-manatus_','Procavia-capensis_','Orycteropus-afer_','Echinops-telfairi_','Dasypus-novemcinctus_','Choloepus-hoffmanni_','Erinaceus-europaeus_','Sorex-araneus_','Pteropus-vampyrus_','Myotis-lucifugus_','Equus-caballus_','Ceratotherium-simum_','Manis-javanica_','Felis-catus_','Canis-familiaris_','Mustela-putorius-furo_','Leptonychotes-weddellii_','Ailuropoda-melanoleuca_','Ursus-maritimus_','Camelus-bactrianus_','Vicugna-pacos_','Sus-scrofa_','Odocoileus-virginianus_','Bubalus-bubalis_','Bison-bison_','Bos-taurus_','Ovis-aries_','Capra-hircus_','Balaenoptera-acutorostrata_','Physeter-catodon_','Lipotes-vexillifer_','Tursiops-truncatus_','Orcinus-orca_','Tupaia-belangeri_','Oryctolagus-cuniculus_','Ochotona-princeps_','Ictidomys-tridecemlineatus_','Fukomys-damarensis_','Heterocephalus-glaber_','Octodon-degus_','Chinchilla-lanigera_','Cavia-porcellus_','Cavia-aperea_','Dipodomys-ordii_','Jaculus-jaculus_','Nannospalax-galili_','Peromyscus-maniculatus_','Cricetulus-griseus_','Rattus-norvegicus_','Mus-pahari_','Mus-spretus_','Mus-musculus_','Otolemur-garnettii_','Microcebus-murinus_','Propithecus-coquereli_','Carlito-syrichta_','Aotus-nancymaae_','Callithrix-jacchus_','Cebus-capucinus_','Saimiri-boliviensis-boliviensis_','Colobus-angolensis-palliatus_','Rhinopithecus-roxellana_','Rhinopithecus-bieti_','Chlorocebus-sabaeus_','Papio-anubis_','Cercocebus-atys_','Mandrillus-leucophaeus_','Macaca-nemestrina_','Macaca-fascicularis_','Macaca-mulatta_','Nomascus-leucogenys_','Pongo-abelii_','Gorilla-gorilla_','Pan-troglodytes_','Pan-paniscus_','Homo-sapiens_')
} else {
  greenPrefixes   <- c('Lepisosteus-oculatus_')
  purplePrefixes  <- c('Scleropages-formosus_','Paramormyrops-kingsleyae_')
  orangePrefixes  <- c('Clupea-harengus_','Ictalurus-punctatus_','Astyanax-mexicanus_','Pygocentrus-nattereri_','Danio-rerio_','Sinocyclocheilus-grahami_','Cyprinus-carpio_')
  redPrefixes     <- c('Esox-lucius_','Salmo-salar_','Salvelinus-alpinus_','Oncorhynchus-mykiss_','Oncorhynchus-tshawytscha_','Oncorhynchus-kisutch_')
  bluePrefixes    <- c('Gadus-morhua_','Gasterosteus-aculeatus_','Notothenia-coriiceps_','Larimichthys-crocea_','Labrus-bergylta_','Tetraodon-nigroviridis_','Takifugu-rubripes_','Cynoglossus-semilaevis_','Paralichthys-olivaceus_','Lates-calcarifer_','Seriola-lalandi-dorsalis_','Seriola-dumerili_','Stegastes-partitus_','Amphiprion-ocellaris_','Acanthochromis-polyacanthus_','Oreochromis-niloticus_','Neolamprologus-brichardi_','Pundamilia-nyererei_','Maylandia-zebra_','Haplochromis-burtoni_','Boleophthalmus-pectinirostris_','Hippocampus-comes_','Monopterus-albus_','Oryzias-latipes_','Oryzias-melastigma_','Nothobranchius-furzeri_','Austrofundulus-limnaeus_','Cyprinodon-variegatus_','Fundulus-heteroclitus_','Xiphophorus-maculatus_','Poecilia-formosa_','Poecilia-reticulata_')
}


#######


fontNumChange <- function (tr)
{
  tipFontNums              <- rep(1, length(tr$tip.label))
  return (tipFontNums)
}


tipColorChange <- function (tr)
{
  orangeNum <- c(); blueNum <- c(); redNum <- NULL; greenNum <- c(); purpleNum <- c(); humanNum <- c()

  for(i in 1:length(tr$tip.label)){

    for (greenPrefix in greenPrefixes){
      if(regexpr(greenPrefix, tr$tip.label[i]) > 0){
        greenNum <- c(greenNum,i)
      }
    }

    for (purplePrefix in purplePrefixes){
      if(regexpr(purplePrefix, tr$tip.label[i]) > 0){
        purpleNum <- c(purpleNum,i)
      }
    }
  
    for (orangePrefix in orangePrefixes){
      if(regexpr(orangePrefix, tr$tip.label[i]) > 0){
        orangeNum <- c(orangeNum,i)
      }
    }
  
    for (redPrefix in redPrefixes){
      if(regexpr(redPrefix, tr$tip.label[i]) > 0){
        redNum <- c(redNum,i)
      }
    }  
  
    for (bluePrefix in bluePrefixes){
      if(regexpr(bluePrefix, tr$tip.label[i]) > 0){
        blueNum <- c(blueNum,i)
      }
    }
  
  }

  tipColorNums             <- rep("black",length(tr$tip.label))
  tipColorNums[greenNum]   <- "darkgreen"
  tipColorNums[purpleNum]  <- "purple"
  tipColorNums[orangeNum]  <- "darkorange1"
  tipColorNums[redNum]     <- "hotpink2"
  tipColorNums[blueNum]    <- "blue"

  return(tipColorNums)
}


PDF_treeDrawing <- function (tr, prefix)
{
  pdf.file <- paste(outfileName, prefix, sep = "")
  pdfWidth  <- NULL
  pdfHeight <- NULL
  if (length(tr$tip.label) > 200) {
    pdfWidth  = 38
    pdfHeight = 28
  } else if (length(tr$tip.label) > 100) {
    pdfWidth  = 31
    pdfHeight = 21
  } else if (length(tr$tip.label) > 50) {
    pdfWidth  = 24
    pdfHeight = 14
  } else if (length(tr$tip.label) > 10) {
    pdfWidth  = 25
    pdfHeight = 10
  } else {
    pdfWidth  = 15
    pdfHeight = 7
  }

  pdf(pdf.file, width = pdfWidth, height = pdfHeight)
  plot      (tr, no.margin=TRUE, underscore = TRUE, use.edge.length=TRUE, cex = 0.9, font = tipFontNums, tip.col = tipColorNums)
  nodelabels(tr$node.label, adj = c(1.2,-0.5), frame = "n")

  dev.off()
}

##################################################################


Gene_tree    <- "tree.txt"
Gene_tree    <- read.tree(Gene_tree)
Gene_tree    <- ladderize(Gene_tree, TRUE)

tipFontNums  <- fontNumChange(Gene_tree)
tipColorNums <- tipColorChange(Gene_tree)

PDF_treeDrawing(Gene_tree, prefix=".pdf")

